/**
 ** coldmanMainCodels.cc
 **
 ** Codels called by execution task coldmanMain
 **
 ** Author: 
 ** Date: 
 **
 **/

#include <portLib.h>

#include "server/coldmanHeader.h"

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <coldman.h>
#include <math.h>

static POSTER_ID poster_motion = NULL;
static POSTER_ID poster_text = NULL;
static bool initIsDone= false;

STATUS coldmanMainStart(int *report)
{

  return OK;
}


/*------------------------------------------------------------------------
 *
 * coldmanMainEnd  --  Termination codel
 *
 * Description: 
 * 
 * Returns:    OK or ERROR
 */

STATUS
coldmanMainEnd()
{
  return OK;
}

/*------------------------------------------------------------------------
 *
 * coldmanMainPerm  --  1st codel of permanent activity (called BEFORE other activities)
 *
 * Description: 
 * 
 * Reports:      OK
 *              S_coldman_COLDMAN_INIT_FAILED
 * 
 * Returns:    OK or ERROR
 */

STATUS
coldmanMainPerm(int *report)
{
  bool result;
  if(initIsDone == false) {
    return OK;
  }
  result= coldmanCheckCollision();
  if(result==true) { 
    SDI_F->collision= GEN_TRUE;
  }
  else { 
    SDI_F->collision= GEN_FALSE;
  }

  if(SDI_F->display==GEN_TRUE) { 
    coldmanDisplayMainLoopEvent();
  }
  return OK;
}

/*------------------------------------------------------------------------
 * Init
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_COLDMAN_INIT_FAILED
 */

/* coldmanInitMain  -  codel EXEC of Init
   Returns:  EXEC LEAVEMAINLOOP ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanInitMain(COLDMANInitStr *initStruct, int *report)
{

  
  if(initIsDone==false) { 
    initIsDone= true;
    SDI_F->display = initStruct->display;
    if(SDI_F->display==GEN_TRUE){ 
         coldmanDisplayInit();
	 coldmanSetText("Coldman Init OK", 0, 20);
    }
    coldmanEnvInit(initStruct->path.name, initStruct->file.name);
  }
  return ETHER;
}



/*------------------------------------------------------------------------
 * ActivateDisplay
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_CANNOT_ACTIVATE_DISPLAY
 */

/* coldmanActivateDisplayMain  -  codel EXEC of ActivateDisplay
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanActivateDisplayMain(int *report)
{
  if(SDI_F->display==GEN_TRUE)
  {   return ETHER;  }
  SDI_F->display= GEN_TRUE;
  coldmanDisplayOn();
  return ETHER;
}




/*------------------------------------------------------------------------
 * DeactivateDisplay
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_CANNOT_ACTIVATE_DISPLAY
 */

/* coldmanDeactivateDisplayMain  -  codel EXEC of DeactivateDisplay
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanDeactivateDisplayMain(int *report)
{
  if(SDI_F->display==GEN_FALSE)
  {   return ETHER;  }
  SDI_F->display= GEN_FALSE;
  coldmanDisplayOff();
  return ETHER;
}



/* coldmanSetQiMain  -  codel EXEC of SetQi
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanSetQiMain(GENMANIP_DOF*qi, int *report)
{
  if(coldmanSetRobotQi(qi->index, qi->value, 0.0, 0.0) == true) {
    *report=  S_coldman_INVALID_INDEX_OR_VALUE;
    return ETHER;
  }

  if(SDI_F->display=GEN_TRUE) { 
    coldmanDisplayRefresh();
  }
  return ETHER;
}


/* coldmanCheckConfigurationMain  -  codel EXEC of CheckConfiguration
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanCheckConfigurationMain(int *report)
{
  bool result;
  unsigned int i;
  
  strcpy(SDI_F->collidingBody1.name, "none");
  strcpy(SDI_F->collidingBody2.name, "none");

  result= coldmanCheckCollision();

  if(result==true)
  { 
    printf("collision\n");
    SDI_F->collision= GEN_TRUE;
    //for(i=0; i<world.robot.nbBodies(); ++i)
    //{
    //   if(world.robot.bodies[i]->colliding)
    //   {
    //     if( strcmp(SDI_F->collidingBody1.name, "none")== 0)
    //     {
    //       strcpy(SDI_F->collidingBody1.name, world.robot.bodies[i]->name().c_str());
    //     }
    //     else
    //     {
    //       strcpy(SDI_F->collidingBody2.name, world.robot.bodies[i]->name().c_str());
    //     }
    //   }
    //}
    //printf("between %s and %s\n", SDI_F->collidingBody1.name, SDI_F->collidingBody2.name);
  }
  else
  { 
    printf("no collision\n");
    SDI_F->collision= GEN_FALSE;
  }
  return ETHER;
}

/*------------------------------------------------------------------------
 * UpdatePoseFromRobot
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_POSTER_NOT_FOUND
 *              S_coldman_POSTER_NOT_READ
 */

/* coldmanUpdatePoseFromRobotStart  -  codel START of UpdatePoseFromRobot
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanUpdatePoseFromRobotStart(COLDMANrequestUpdateStr *requestUpdatePose, int *report)
{
  if (coldmanGENMANIP_MOTION_STRPosterFind(requestUpdatePose->posterName.name, &poster_motion) == ERROR) {
    *report =  S_coldman_POSTER_NOT_FOUND ; 
    return ETHER;
  }
  if (coldmanGENMANIP_MOTION_STRPosterRead(poster_motion, &SDI_F->motion) == ERROR) {
    *report =  S_coldman_POSTER_NOT_READ ; 
    return ETHER;
  }
  return EXEC;
}

/* coldmanUpdatePoseFromRobotMain  -  codel EXEC of UpdatePoseFromRobot
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanUpdatePoseFromRobotMain(COLDMANrequestUpdateStr *requestUpdatePose, int *report)
{
  if (coldmanGENMANIP_MOTION_STRPosterRead(poster_motion, &SDI_F->motion) == ERROR) {
    *report =  S_coldman_POSTER_NOT_READ ; 
    return ETHER;
  }
  
  for(int i=0; i<SDI_F->motion.size; i++) {
    if( coldmanSetRobotQi(i,SDI_F->motion.q[i],SDI_F->motion.vq[i],SDI_F->motion.aq[i])==true) {
      *report=  S_coldman_INVALID_INDEX_OR_VALUE;
      return ETHER;
    }
  }
  if(SDI_F->display=GEN_TRUE) { 
    coldmanDisplayRefresh();
  }
  return EXEC;
}

/* coldmanUpdatePoseFromRobotEnd  -  codel END of UpdatePoseFromRobot
   Returns:  END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanUpdatePoseFromRobotEnd(COLDMANrequestUpdateStr *requestUpdatePose, int *report)
{
  /* ... add your code here ... */
  return ETHER;
}

/* coldmanUpdatePoseFromRobotInter  -  codel INTER of UpdatePoseFromRobot
   Returns:  INTER ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanUpdatePoseFromRobotInter(COLDMANrequestUpdateStr *requestUpdatePose, int *report)
{
  /* ... add your code here ... */
  return ETHER;
}




/*------------------------------------------------------------------------
 * DisableObstacleCollision
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OBSTACLE_UNDEFINED
 */

/* coldmanDisableObstacleCollisionMain  -  codel EXEC of DisableObstacleCollision
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanDisableObstacleCollisionMain(GEN_STRING128 *obstacle, int *report)
{
  if(coldmanDisableObstacleCollision(obstacle->name)!=0) {
    *report=  S_coldman_OBSTACLE_UNDEFINED; 
  }
  else {
    *report=  S_coldman_OK;
  }

  return ETHER;
}




/*------------------------------------------------------------------------
 * EnableObstacleCollision
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OBSTACLE_UNDEFINED
 */

/* coldmanEnableObstacleCollisionMain  -  codel EXEC of EnableObstacleCollision
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanEnableObstacleCollisionMain(GEN_STRING128 *obstacle, int *report)
{
  if(coldmanEnableObstacleCollision(obstacle->name)!=0) {
    *report=  S_coldman_OBSTACLE_UNDEFINED; 
  }
  else {
    *report=  S_coldman_OK;
  }

  return ETHER;
}




/*------------------------------------------------------------------------
 * DisableObstacleDisplay
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OBSTACLE_UNDEFINED
 */

/* coldmanDisableObstacleDisplayMain  -  codel EXEC of DisableObstacleDisplay
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanDisableObstacleDisplayMain(GEN_STRING128 *obstacle, int *report)
{
  if(coldmanDisableObstacleDisplay(obstacle->name)!=0) {
    *report=  S_coldman_OBSTACLE_UNDEFINED; 
  }
  else {
    *report=  S_coldman_OK;
  }


  return ETHER;
}




/*------------------------------------------------------------------------
 * EnableObstacleDisplay
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OBSTACLE_UNDEFINED
 */

/* coldmanEnableObstacleDisplayMainn  -  codel EXEC of EnableObstacleDisplay
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanEnableObstacleDisplayMain(GEN_STRING128 *obstacle, int *report)
{
  if(coldmanEnableObstacleDisplay(obstacle->name)!=0) {
    *report=  S_coldman_OBSTACLE_UNDEFINED; 
  }
  else {
    *report=  S_coldman_OK;
  }


  return ETHER;
}





/*------------------------------------------------------------------------
 * SetObstaclePosition
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OBSTACLE_UNDEFINED
 */

/* coldmanSetObstaclePositionMain  -  codel EXEC of SetObstaclePosition
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanSetObstaclePositionMain(COLDMANsetPositionStr *position, int *report)
{

  if(coldmanSetObstaclePosition(position->name.name, position->x, position->y, position->z)!=0) {
    *report=  S_coldman_OBSTACLE_UNDEFINED; 
  }
  else {
    *report=  S_coldman_OK;
  }


  return ETHER;
}




/*------------------------------------------------------------------------
 * SetObstacleOrientation
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OBSTACLE_UNDEFINED
 */

/* coldmanSetObstacleOrientationMain  -  codel EXEC of SetObstacleOrientation
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanSetObstacleOrientationMain(COLDMANsetOrientationStr *orientation, int *report)
{
  float degtorad= (180.0/M_PI);
  if(coldmanSetObstacleOrientation(orientation->name.name, degtorad*orientation->yaw, degtorad*orientation->pitch, degtorad*orientation->roll)!=0) {
    *report=  S_coldman_OBSTACLE_UNDEFINED; 
  }
  else {
   coldmanDisplayRefresh();
    *report=  S_coldman_OK;
  }

  return ETHER;
}





/*------------------------------------------------------------------------
 * SetObstaclePose
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OBSTACLE_UNDEFINED
 */

/* coldmanSetObstaclePoseMain  -  codel EXEC of SetObstaclePose
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanSetObstaclePoseMain(COLDMANsetPoseStr *pose, int *report)
{
  float degtorad= (180.0/M_PI);
  if(coldmanSetObstaclePose(pose->name.name, pose->x, pose->y, pose->z, degtorad*pose->yaw, degtorad*pose->pitch, degtorad*pose->roll)!=0) {
    *report=  S_coldman_OBSTACLE_UNDEFINED; 
  }
  else {
    coldmanDisplayRefresh();
    *report=  S_coldman_OK;
  }


  return ETHER;
}





/*------------------------------------------------------------------------
 * ListAllObstacles
 *
 * Description: 
 *
 * Reports:      OK
 *   
 */

/* coldmanListAllObstaclesMain  -  codel EXEC of ListAllObstacles
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanListAllObstaclesMain(int *report)
{
  coldmanListAllObstacles();
  *report= OK;
  return ETHER;
}




/*------------------------------------------------------------------------
 * ListCollidingBodies
 *
 * Description: 
 *
 * Reports:      OK
 *     
 */

/* coldmanListCollidingBodiesMain  -  codel EXEC of ListCollidingBodies
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanListCollidingBodiesMain(int *report)
{
  coldmanListCollidingBodies();
  *report= OK;
  return ETHER;
}



/*------------------------------------------------------------------------
 * ChangeCameraAzimuth
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OK
 */

/* coldmanChangeCameraAzimuthMain  -  codel EXEC of ChangeCameraAzimuth
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanChangeCameraAzimuthMain(double *angle, int *report)
{
  coldmanChangeCameraAzimuth(*angle);
  *report= OK;
  return ETHER;
}




/*------------------------------------------------------------------------
 * ChangeCameraElevation
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OK
 */

/* coldmanChangeCameraElevationMain  -  codel EXEC of ChangeCameraElevation
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanChangeCameraElevationMain(double *angle, int *report)
{
  coldmanChangeCameraElevation(*angle);
  *report= OK;
  return ETHER;
}



/*------------------------------------------------------------------------
 * CameraZoom
 *
 * Description: 
 *
 * Reports:      OK
 *              
 */

/* coldmanCameraZoom  -  codel EXEC of CameraZoom
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanCameraZoomMain(double *distance, int *report)
{
  coldmanCameraZoom(*distance);
  *report= OK;
  return ETHER;
}


/*------------------------------------------------------------------------
 * MoveObjectToPredefinedPoe
 *
 * Description: 
 *
 * Reports:      OK
 *              
 */

/* coldmanMoveObjectToPredefinedPose  -  codel EXEC of MoveObjectToPredefinedPose
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanMoveObjectToPredefinedPoseMain(int *predefinedPose, int *report)
{
  int i= *predefinedPose - 1;
  float positions[3][3]= { {1,0,0.94}, {1,0.27,0.94}, {1,-0.27,0.94} };
  float orientations[3][3]= { {M_PI_2,0,-M_PI_2}, {M_PI_2,0,-M_PI_2}, {M_PI_2,0,-M_PI_2} };

  if(i<0 || i>2) {
    *report= S_coldman_WRONG_CHOICE;
    return ETHER;
  }

  if(coldmanSetObstaclePose("caisse", positions[i][0], positions[i][1], positions[i][2], orientations[i][0], orientations[i][1], orientations[i][2])!=0) {
    *report=  S_coldman_OBSTACLE_UNDEFINED; 
  }
  else {
    coldmanDisplayRefresh();
    *report=  S_coldman_OK;
  }

 
  return ETHER;
}

/*------------------------------------------------------------------------
 * EnableShadows
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OK
 */

/* coldman EnableShadows  -  codel EXEC of EnableShadows
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanEnableShadowsMain(int *report)
{
  coldmanEnableShadows();
  *report= OK;
  return ETHER;
}





/*------------------------------------------------------------------------
 * DisableShadows
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OK
 */

/* coldman DisableShadows  -  codel EXEC of DisableShadows
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanDisableShadowsMain(int *report)
{
  coldmanDisableShadows();
  *report= OK;
  return ETHER;
}

/*------------------------------------------------------------------------
 * DisplayText
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_NOT_INITIALIEZD
 *              S_coldman_CANNOT_FIND_POSTER
 *              S_coldman_CANNOT_READ_POSTER
 */

/* coldmanDisplayTextStart  -  codel START of DisplayText
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanDisplayTextStart(GEN_STRING128 *textPosterName, int *report)
{
  if (coldmanGENMANIP_STRING1024PosterFind(textPosterName->name, &poster_text) == ERROR) {
    *report =  S_coldman_POSTER_NOT_FOUND ; 
    return ETHER;
  }
  if (coldmanGENMANIP_STRING1024PosterRead(poster_text, &SDI_F->text) == ERROR) {
    *report =  S_coldman_POSTER_NOT_READ ; 
    return ETHER;
  }
  return EXEC;
}

/* coldmanDisplayTextMain  -  codel EXEC of DisplayText
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanDisplayTextMain(GEN_STRING128 *textPosterName, int *report)
{
  if (coldmanGENMANIP_STRING1024PosterRead(poster_text, &SDI_F->text) == ERROR) {
    *report =  S_coldman_POSTER_NOT_READ ; 
    return ETHER;
  }
 coldmanSetText(SDI_F->text.str, 10, 60);
 //  printText(SDI_F->text.str, 0, 0);
   
  if(SDI_F->display=GEN_TRUE) { 
    coldmanDisplayRefresh();
  }

  return EXEC;
}

/* coldmanDisplayTextEnd  -  codel END of DisplayText
   Returns:  END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanDisplayTextEnd(GEN_STRING128 *textPosterName, int *report)
{
  
  coldmanSetText("", 10, 60);
  if(SDI_F->display=GEN_TRUE) { 
    coldmanDisplayRefresh();
  }

  return ETHER;
}

/* coldmanDisplayTextInter  -  codel INTER of DisplayText
   Returns:  INTER ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanDisplayTextInter(GEN_STRING128 *textPosterName, int *report)
{
  /* ... add your code here ... */
  return ETHER;
}






/*------------------------------------------------------------------------
 * ResizeWindow
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OK
 */

/* coldmanResizeWindowMain  -  codel EXEC of ResizeWindow
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanResizeWindowMain(COLDMANsizeStr *size, int *report)
{

  coldmanResizeWindow(size->x, size->y);

  *report= OK;
  return ETHER;
}



/* coldmanLoadCloudMain  -  codel EXEC of LoadCloud
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanLoadCloudMain(GEN_STRING128 *Name_file, int *report)
{
  if(coldmanLoadPointCloud(Name_file->name)==0)
    *report= OK;
  return ETHER;
}





/*------------------------------------------------------------------------
 * PositionWindow
 *
 * Description: 
 *
 * Reports:      OK
 *              S_coldman_OK
 */

/* coldmanPositionWindowMain  -  codel EXEC of PositionWindow
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanPositionWindowMain(COLDMANsizeStr *size, int *report)
{
  coldmanPositionWindow(size->x, size->y);
  *report= OK;
  return ETHER;
}




/* coldmanRemoveScannedObstaclesMain  -  codel EXEC of RemoveScannedObstacles
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
coldmanRemoveScannedObstaclesMain(int *report)
{
   if(coldmanRemoveScannedObstacles()==0)
    *report= OK;
  return ETHER;
}


